routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    if (Auth::check()) return redirect(route('home'));
    else return view('Auth/login');
});

Route::group(['middleware' => ['auth']], function (){
    Route::get('/user/profile', 'UserController@edit')->name('user_profile');
    Route::patch('/user/profile', 'UserController@update')->name('user_profile_edit');
    Route::get('users', 'UserController@index')->name('users');
    Route::get('users/{id}/profile', 'UserController@show')->name('user_info');
    Route::get('search', 'UserController@autocomplete');

    Route::resource('post', 'PostController');
    Route::get('/home', 'PostController@allPosts')->name('home');
    Route::get('/user/{id}/posts', 'PostController@userFriendPosts')->name('userFriendPosts');
    Route::resource('like', 'LikeController');
    Route::resource('comment', 'CommentController');
    Route::resource('follow', 'FollowController');

});

Auth::routes();

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password', 'first_name', 'last_name', 'birth_date'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function posts(){
        return $this->hasMany(Post::class);
    }

    public function following(){
        return $this->hasMany(Follower::class, 'from_user_id');
    }

    public function follower(){
        return $this->hasMany(Follower::class, 'to_user_id');
    }

}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Follower;
use App\Like;
use App\Post;
use App\User;
use Illuminate\Http\Request;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $users = User::where('id', '!=', auth()->id())->get();
        $requests=Follower::with('to_user')->where(['from_user_id'=> auth()->id(), 'accepted' => 0])->get();
        $active_users = 'primary';
        return view('user.index', compact('users', 'active_users', 'requests'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request, $id)
    {
        //
        $request->id = $id;
        $user = User::find($request->id);
        $posts = Post::where(['user_id'=>$request->id])->limit(3)->get();
        $posts_count = Post::where(['user_id'=>$request->id])->count();
        $likes_count =Like::whereIn('post_id', Post::where(['user_id'=>$request->id])->get()->pluck('id'))->count();
        $is_follower = Follower::where(['from_user_id' => auth()->id(), 'to_user_id' => $request->id])->first();

        return view('auth.user_info',compact('user', 'posts', 'posts_count', 'likes_count', 'is_follower'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit()
    {
        //view edit page
        $user = User::find(Auth()->id());
        $active_profile='primary';
        return view('auth.user_profile', compact('user', 'active_profile'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
//    public function update(Request $request, $id)
    public function update(Request $request)
    {
        //
        $img_name='';
        if ($request->hasFile('filename')){
            $file = $request->file('filename');
            $img_name = auth()->id().'-'.time().'-'.$file->getClientOriginalName();
            $file->move(public_path().'/images/avatar',$img_name);
        }
        $user = User::find(Auth()->id());
        $user->first_name = $request->get('first_name');
        $user->last_name = $request->get('last_name');
        $user->birth_date = $request->get('birth_date');
        if (strlen($img_name))
            $user->avatar = $img_name;
        $user->save();
        return $this->edit();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function autocomplete(Request $request){
        $results=array();
        $item = $request->searchname;
        $data = User::where('first_name', 'LIKE', '%'.$item.'%')->orWhere('last_name', 'LIKE', '%'.$item.'%')
            ->take(5)
            ->get();
        return response()->json($data);
    }
}

resources/views/user/index.blade.php
@extends('layouts.app')

@section('content')
<div class="album py-5 bg-light">
    <div class="container">
        <div class="row">
            <div class="col-md-6">
                <div class="my-3 p-3 bg-white rounded box-shadow" style="direction:  rtl;text-align:  right;">
                    <h6 class="border-bottom border-gray pb-2 mb-0">المستخدمين</h6>
                    @foreach($users as $user)
                    <!-- Foreach User  -->
                    <div class="media text-muted pt-3">
                        <img src="{{ asset('images/avatar/'.$user->avatar) }}" alt="" class="col-sm-2 mr-2 rounded" style="margin-right: -3%;width: 50px;height: 40px;margin-top:  -1%;">
                        <div class="media-body pb-3 mb-0 small lh-125 border-bottom border-gray" >
                            <div class="d-flex justify-content-between align-items-center w-100">
                                <a href="{{ route('user_info', $user->id) }}">
                                    <strong class="text-gray-dark">{{ $user->name }}</strong>
                                </a>
                                <form action="{{ route('follow.store') }}" method="POST">
                                    @csrf
                                    <input type="hidden" name="user_id" value="{{ $user->id }}">
                                    <button type="submit" class="btn btn-outline-secondary">add</button>

                                </form>
                            </div>
                        </div>
                    </div>
                    <!-- End Foreach User  -->
                    @endforeach
                    <small class="d-block text-right mt-3">
                        <a href="#">جميع المستخدمين</a>
                    </small>
                </div>
            </div>
            <div class="col-md-6">
                <div class="my-3 p-3 bg-white rounded box-shadow" style="direction:  rtl;text-align:  right;">
                    <h6 class="border-bottom border-gray pb-2 mb-0">الطلبات المرسلة</h6>
                    <!-- Foreach Follow Requset  -->
                    @foreach($requests as $request)
                    <div class="media text-muted pt-3">
                        <img src="{{ asset('images/avatar/'.$request->to_user->avatar) }}" alt="" class="col-sm-2 mr-2 rounded" style="margin-right: -3%;width: 50px;height: 40px;margin-top:  -1%;">
                        <div class="media-body pb-3 mb-0 small lh-125 border-bottom border-gray" >
                            <div class="d-flex justify-content-between align-items-center w-100">
                                <strong class="text-gray-dark">{{ $request->to_user->name }}</strong>
                                <form method="POST" action="{{ route('follow.destroy', $request->id) }}">
                                    @method('DELETE')
                                    @csrf
                                    <button type="submit" class="btn btn-outline-danger">cancel</button>
                                </form>
                            </div>
                            <span class="d-block">تم إرساله بتاريخ {{ $request->created_at }}</span>
                        </div>
                    </div>
                    @endforeach
                    <!-- End Foreach Follow Requset  -->
                    <small class="d-block text-right mt-3">
                        <a href="#">جميع التحديثات</a>
                    </small>
                </div>
            </div>
        </div>

    </div>
</div>
@endsection